#pragma once
#include "ISceneNode.h"
#include "IVisitor.h"
#include <string>

namespace OhioState
{
	namespace Graphics 
	{
		//
		// Abstract material node.
		//   Extends the ISceneNode with a method to enable
		//   a material.
		//
		class IMaterialNode : public ISceneNode
		{
		public:
			//
			// Enable the material associated with this IMaterialNode.
			//
			virtual void EnableMaterial() = 0;
			//
			// Overrided from ISceneNode
			//
			virtual void Accept(IVisitor* visitor)
			{
				visitor->Visit(this);
			}
		};
	}
}