#pragma once

namespace OhioState
{
	namespace Graphics
	{
		class IDrawableNode;
		class IMaterialNode;
		class ITransformNode;
		class IStateNode;
		class GroupNode;

		class IVisitor
		{
		public:
			virtual void Visit(IDrawableNode* drawable) = 0;
			virtual void Visit(IMaterialNode* drawable) = 0;
			virtual void Visit(ITransformNode* transform) = 0;
			virtual void Visit(IStateNode* state) = 0;
			virtual void Visit(GroupNode* group) = 0;
		};
	}
}